﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Windows;

namespace EventGeneration
{
    public class MouseEvent
    {
        [DllImport("user32.dll")]
        static extern void mouse_event(uint dwFlags, uint dx, uint dy, uint dwData, UIntPtr dwExtraInfo);

        private const uint MOUSEEVENTF_LEFTDOWN = 0x02;
        private const uint MOUSEEVENTF_LEFTUP = 0x04;
        private const uint MOUSEEVENTF_RIGHTDOWN = 0x08;
        private const uint MOUSEEVENTF_RIGHTUP = 0x10;

        public static void EventMoveMouse(Point move_by)
        {
            Position = new Point(Position.X + move_by.X, Position.Y + move_by.Y);
        }

        public static void EventAbsoluteMousePosition(Point position)
        {
            Position = position;
        }

        public static void EventLeftClick()
        {
            mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, new UIntPtr(0));
            mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, new UIntPtr(0));
        }

        public static void EventRightClick()
        {
            mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, new UIntPtr(0));
            mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, new UIntPtr(0));
        }

        public static void EventStartLeftDrag()
        {
            mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, new UIntPtr(0));
        }

        public static void EventEndLeftDrag()
        {
            mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, new UIntPtr(0));
        }

        public static void EventStartRightDrag()
        {
            mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, new UIntPtr(0));
        }

        public static void EventEndRightDrag()
        {
            mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, new UIntPtr(0));
        }

        private static Point Position
        {
            get {
                System.Drawing.Point point = System.Windows.Forms.Cursor.Position;
                return new Point(point.X, point.Y); 
            }
            set { System.Windows.Forms.Cursor.Position = new System.Drawing.Point((int)value.X, (int)value.Y); }
        }
    }
}
