﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Runtime.InteropServices;
using EventGeneration;

namespace EventGenerationTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        [DllImport("user32.dll")]
        static extern void mouse_event(uint dwFlags, uint dx, uint dy, uint dwData, UIntPtr dwExtraInfo);

        private const uint MOUSEEVENTF_LEFTDOWN = 0x02;
        private const uint MOUSEEVENTF_LEFTUP = 0x04;
        private const uint MOUSEEVENTF_RIGHTDOWN = 0x08;
        private const uint MOUSEEVENTF_RIGHTUP = 0x10;

        [DllImport("user32.dll")]
        static extern void keybd_event(byte bVk, byte bScan, uint dwFlags, uint dwExtraInfo);

        const int VK_CONTROL = 0x11;


        private Point m_start = new Point(600, 150);

        public MainWindow()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            EventGeneration.MouseEvent.EventAbsoluteMousePosition(m_start);
            EventGeneration.MouseEvent.EventLeftClick();
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            EventGeneration.MouseEvent.EventAbsoluteMousePosition(m_start);
            EventGeneration.MouseEvent.EventRightClick();
        }

        private void button3_Click(object sender, RoutedEventArgs e)
        {
            EventGeneration.MouseEvent.EventAbsoluteMousePosition(m_start);
            EventGeneration.MouseEvent.EventStartLeftDrag();
            SimulateMouseMove();
            EventGeneration.MouseEvent.EventEndLeftDrag();
        }

        private void button4_Click(object sender, RoutedEventArgs e)
        {
            EventGeneration.MouseEvent.EventAbsoluteMousePosition(m_start);
            EventGeneration.KeyboardEvent.EventKeyDownShift();
            EventGeneration.MouseEvent.EventStartLeftDrag();
            SimulateMouseMove();
            EventGeneration.MouseEvent.EventEndLeftDrag();
            EventGeneration.KeyboardEvent.EventKeyUpShift();
        }

        private static void SimulateMouseMove()
        {
            for (int i = 0; i < 10; i++)
            {
                System.Threading.Thread.Sleep(200);
                EventGeneration.MouseEvent.EventMoveMouse(new Point(0, 10));
            }
        }
    }
}
