﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Research.Kinect.Nui;
using Sensor.Gesture.Common;

namespace Sensor.Common
{
    public static class CommonGestureDecisions
    {
        private const double s_stretched_full = 4000;
        private const double s_stretched_partial = 3000;
        
        public static bool StretchedOutFully(JointsCollection js, JointID joint){
            return DistanceFromShoulderCenter(js, joint) >= s_stretched_full;
        }

        public static bool StretchedOutPartially(JointsCollection js, JointID joint)
        {
            return DistanceFromShoulderCenter(js, joint) >= s_stretched_partial;
        }

        public static double DistanceFromShoulderCenter(JointsCollection js, JointID joint)
        {
            int left_depth_millimeter = JointUtil.DepthMillimeter(js[joint]);
            int shoulder_center_depth_millimeter = JointUtil.DepthMillimeter(js[JointID.ShoulderCenter]);
            return shoulder_center_depth_millimeter - left_depth_millimeter;
        }


    }
}
