﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;

namespace Sensor.Gesture.Common
{
    public static class PointUtil
    {
        private const double s_point_smoothing_alpha = 1;

        public static double Distance(Point point_1, Point point_2) {
            return Math.Sqrt(Square(point_1.X - point_2.X) + Square(point_1.Y - point_2.Y));
        }

        public static Point Subtract(Point point_1, Point point_2)
        {
            return new Point(point_1.X - point_2.X, point_1.Y - point_2.Y);
        }

        public static Point Add(Point point_1, Point point_2)
        {
            return new Point(point_1.X + point_2.X, point_1.Y + point_2.Y);
        }

        public static double Square(double d) {
            return Math.Pow(d, 2);
        }

        public static double Magnitude(Point p)
        {
            return Math.Abs(p.X) + Math.Abs(p.Y);
        }

        public static Point SmoothMovementDelta(Point previous, Point current)
        {
            if (Magnitude(previous) == 0) return current;

            return new Point(
                s_point_smoothing_alpha * (current.X - previous.X),
                s_point_smoothing_alpha * (current.Y - previous.Y)
            );
        }
    }
}
