﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sensor.MouseAction
{
    public class DoubleClickAction : INoArgumentAction
    {
        private double s_minimum_second_between_clicks = 5;

        private DateTime? m_last_click_time;
        MouseButton m_button;

        public DoubleClickAction(MouseButton button)
        {
            m_last_click_time = null;
            m_button = button;
        }

        public void Execute()
        {
            if (m_last_click_time.HasValue &&
                (DateTime.Now - m_last_click_time.Value).Seconds < s_minimum_second_between_clicks)
            {
                return;
            }
            switch (m_button)
            {
                case MouseButton.Left:
                    EventGeneration.MouseEvent.EventLeftClick();
                    EventGeneration.MouseEvent.EventLeftClick();
                    break;
                case MouseButton.Right:
                    EventGeneration.MouseEvent.EventRightClick();
                    EventGeneration.MouseEvent.EventRightClick();
                    break;
                default:
                    throw new ArgumentException("Unexpected case : " + m_button);
            }

            m_last_click_time = DateTime.Now;
        }
    }
}
